Package org.optaplanner.core.impl.heuristic.selector.entity.pillar

## Class PillarSelectorFactory<Solution_>

- java.lang.Object
- - org.optaplanner.core.impl.AbstractFromConfigFactory<Solution_,​SelectorConfig_>
  - - org.optaplanner.core.impl.heuristic.selector.AbstractSelectorFactory<Solution_,​PillarSelectorConfig>
    - - org.optaplanner.core.impl.heuristic.selector.entity.pillar.PillarSelectorFactory<Solution_>

-     public class PillarSelectorFactory<Solution_>
      extends AbstractSelectorFactory<Solution_,​PillarSelectorConfig>

- - ### Field Summary

    - ### Fields inherited from class org.optaplanner.core.impl.AbstractFromConfigFactory

      `config`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `PillarSelectorFactory​(PillarSelectorConfig pillarSelectorConfig)` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `PillarSelector<Solution_>` | `buildPillarSelector​(HeuristicConfigPolicy<Solution_> configPolicy, SubPillarType subPillarType, Class<? extends Comparator> subPillarSequenceComparatorClass, SelectionCacheType minimumCacheType, SelectionOrder inheritedSelectionOrder, List<String> variableNameIncludeList)` |
    `static <Solution_> PillarSelectorFactory<Solution_>` | `create​(PillarSelectorConfig pillarSelectorConfig)` |

    - ### Methods inherited from class org.optaplanner.core.impl.heuristic.selector.AbstractSelectorFactory

      `validateCacheTypeVersusSelectionOrder`

    - ### Methods inherited from class org.optaplanner.core.impl.AbstractFromConfigFactory

      `deduceEntityDescriptor, deduceEntityDescriptor, deduceVariableDescriptor, deduceVariableDescriptor, deduceVariableDescriptorList`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### PillarSelectorFactory

          public PillarSelectorFactory​(PillarSelectorConfig pillarSelectorConfig)

  - ### Method Detail

    - #### create

          public static <Solution_> PillarSelectorFactory<Solution_> create​(PillarSelectorConfig pillarSelectorConfig)

    - #### buildPillarSelector

          public PillarSelector<Solution_> buildPillarSelector​(HeuristicConfigPolicy<Solution_> configPolicy,
                                                               SubPillarType subPillarType,
                                                               Class<? extends Comparator> subPillarSequenceComparatorClass,
                                                               SelectionCacheType minimumCacheType,
                                                               SelectionOrder inheritedSelectionOrder,
                                                               List<String> variableNameIncludeList)

      Parameters:
        `configPolicy` - never null
        `subPillarType` - if null, defaults to `SubPillarType.ALL` for backwards compatibility reasons.
        `subPillarSequenceComparatorClass` - if not null, will force entites in the pillar to come in this order
        `minimumCacheType` - never null, If caching is used (different from `SelectionCacheType.JUST_IN_TIME`), then it should be at least this `SelectionCacheType` because an ancestor already uses such caching and less would be pointless.
        `inheritedSelectionOrder` - never null
        `variableNameIncludeList` - sometimes null
      Returns:
        never null